#include <stdio.h>
#include <stdlib.h>
#include "../cputime.h"
#ifdef _OPENMP
#include <omp.h>
#endif

main(int argc, char **argv)
{
  int i, j, N, M, T;
  double **a, *v, *res, sum=0.0, t1=0.0, t2=0.0;

  if(argc != 4)
    {
      fprintf(stderr,"Usage: %s N M NumberOfThreads\n", argv[0]);
      exit(-1);
    }

  
  N = atoi(*++argv);
  M = atoi(*++argv);
  T = atoi(*++argv);
  a = malloc(N*sizeof(*a));
  v = malloc(M*sizeof(*v));
  res = calloc(N,sizeof(*res));
  
#ifdef _OPENMP
  omp_set_num_threads(T);
  omp_set_dynamic(1);
  omp_set_nested(1);
  printf("Number of processors = %d\n", omp_get_num_procs());
#endif

  for(i=0; i<N; i++)
    a[i] = malloc(M*sizeof(**a));

  for(i=0; i<N; i++)
    for(j=0; j<M; j++)
      a[i][j] = i+j;

  for(j=0; j<M; j++)
    v[j] = 1.0/(double) (1+j);
  
  t1 = cputime();

#pragma omp parallel for // private(j)
  for(i=0; i<N; i++)
    //#pragma omp parallel for 
    for(j=i; j<M; j++)
      res[i] += a[i][j]*v[j];
  t2 = cputime();

  for(i=0; i<N; i++)
    sum += res[i];

  printf("Sum = %g, time = %f seconds\n", sum, t2-t1);

}
